!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine DisturbEnv
!
!   * Developer: SUGIYAMA Ko-ichiro, ODAKA Masatsugu
!   * Version: $Id: disturbenv_mmc.f90,v 1.1 2011-03-30 13:53:07 sugiyama Exp $ 
!   * Tag Name: $Name: arare4-20120511 $
!   * Change History: 
!
!== Overview 
!
!ΥǥեͤͿ뤿Υ롼. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
! * ή׻
!
!== Future Plans
!
!  * ǽʾΥפ䤹
!  * 顼 gf4f90io 
!

subroutine DisturbEnv_mmc(                                   &
  &    cfgfile, xz_PotTemp, xz_Exner, pz_VelX, xr_VelZ,  &
  &    xz_Km, xz_Kh, xz_DensCloud, xz_SatRatio           &
  &  )
  !
  !ΥǥեͤͿ뤿Υ롼. 
  !
  
  !⥸塼ɤ߹
  use dc_message, only: MessageNotify

  use gridset,    only:DimXMin,         &!  X β
    &                  DimXMax,         &!  X ξ
    &                  RegXMin,         &!  X β
    &                  RegXMax,         &!  X ξ
    &                  DimZMin,         &!  Z β
    &                  DimZMax,         &!  Z ξ
    &                  RegZMin,         &!  Z β
    &                  RegZMax,         &!  Z ξ
    &                  MarginZ,         &! ׻ΰΥޡ
    &                  DelZ,            &! Z ι
    &                  SpcNum,          &! Žؼο
    &                  XMin, XMax,      &! 
    &                  ZMin, ZMax,      &! 
    &                  s_X,             &! X ɸ(顼ʻ)
    &                  s_Z               ! Z ɸ(顼ʻ)
  use fileset,    only:RandomFile        ! ե
  use basicset,   only:                 &
    &                  SpcWetMolFr,     &!Žʬν
    &                  MolWtWet,        &!Žʬʬ
    &                  MolWtDry,        &!ʬʬ
    &                  xz_PotTempBasicZ, &! ܾβ
    &                  xz_TempBasicZ,   &! ܾβ
    &                  xz_PressBasicZ,  &! ܾΰ
    &                  xz_ExnerBasicZ,  &! ̵
    &                  TempSfc,         &! ɽ̲
    &                  PressSfc,        &! ɽ̰
    &                  GasRDry,         &! ʬε
    &                  CpDry,           &! ʬ갵Ǯ
    &                  Grav              ! ϲ®
  use ChemData, only:  ChemData_SVapPress_AntoineA, &!Antoine μη
    &                  ChemData_SVapPress_AntoineB   !Antoine μη

  !ۤηػ
  implicit none
  
  !ѿ
  character(*), intent(in) :: cfgfile
  real(8), intent(out)  :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !ʿ®ξʬ
  real(8), intent(out)  :: xr_VelZ(DimXMin:DimXMax,DimZMin:DimZMax) 
                                    !ľ®ξʬ 
  real(8), intent(out)  :: xz_Exner(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !ʡؿξʬ 
  real(8), intent(out)  :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !̤ξʬ 
  real(8), intent(out)  :: xz_Km(DimXMin:DimXMax,DimZMin:DimZMax)
                                    !ư̤ФȻ
  real(8), intent(out)  :: xz_Kh(DimXMin:DimXMax,DimZMin:DimZMax)
                                    !ǮФȻ
  real(8), intent(out)  :: xz_DensCloud(DimXMin:DimXMax,DimZMin:DimZMax)
                                    !̩
  real(8), intent(out)  :: xz_SatRatio(DimXMin:DimXMax,DimZMin:DimZMax)
                                    !˰
  real(8), parameter         :: Pi = 3.1415926535897932385d0 
                                    !߼Ψ
  real(8)       :: XcRate = 0.0d0   !濴(ʿ)ΰФ
  real(8)       :: XrRate = 0.0d0   !Ⱦ(ʿ)ΰФ
  real(8)       :: ZcRate = 0.0d0   !濴(ľ)ΰФ
  real(8)       :: ZrRate = 0.0d0   !Ⱦ(ľ)ΰФ
  real(8)       :: Xc     = 0.0d0   !濴(ʿ)
  real(8)       :: Xr     = 0.0d0   !Ⱦ(ʿ)
  real(8)       :: Zc     = 0.0d0   !濴(ľ)
  real(8)       :: Zr     = 0.0d0   !Ⱦ(ľ)
  real(8)       :: Zpos   = 0.0d0   ! Z ɸ [m] (Therma-Random )
  real(8)       :: DelMax = 0.0d0   !̾κ
  real(8)       :: HalfWidth = 0.0d0!̾Ⱦ
  real(8)       :: ShearWidth= 0.0d0!ؤ
  real(8)       :: Random           !ե뤫
  real(8)       :: RandomNum(DimXMin:DimXMax)
  real(8)       :: RandomNum2(DimXMin:DimXMax)
  character(20) :: Type             !̾Υ
  integer       :: i, k, s, n       ! DO 롼ѿ

  !-------------------------------------------------------------
  ! 
  !-------------------------------------------------------------
  !NAMELIST եɤ߹
  NAMELIST /disturbset/ &
    & Type, DelMax, XrRate, XcRate, ZrRate, ZcRate, &
    & Zpos, HalfWidth, ShearWidth

  open (10, FILE=cfgfile)
  read(10, NML=disturbset)
  close(10)
  
  !
  pz_VelX    = 0.0d0
  xr_VelZ    = 0.0d0
  xz_Exner   = 0.0d0
  xz_PotTemp = 0.0d0
  xz_Km      = 0.0d0
  xz_Kh      = 0.0d0
  xz_DensCloud = 0.0d0
  xz_SatRatio = 0.0d0

  Xr = (XMax - XMin) * XrRate
  Xc = (XMax - XMin) * XcRate
  Zr = (ZMax - ZMin) * ZrRate
  Zc = (ZMax - ZMin) * ZcRate

  !-------------------------------------------------------------
  ! ̤ξ
  !-------------------------------------------------------------
  select case(Type)
    
  case ("Kitamori-Gauss")
    ! ̼(2006) η׻. 
    ! ꤵ줿ɸ濴Ȥʬۤβ̾Ϳ. 
    ! ܾ찵ʬۤ˰¾˰Ϳ. 

    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        
        xz_PotTemp(i,k) = &
          & DelMax * dexp( - ( (s_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1   &
          &                - ( (s_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) 
        
        xz_SatRatio(i,k) = &
          & PressSfc * (xz_ExnerBasicZ(i,k) + xz_Exner(i,k))**(CpDry / GasRDry) &
          & * ( exp(  &
          &         - ChemData_SVapPress_AntoineA(12) &
          &         + ChemData_SVapPress_AntoineB(12) &
          &           / ( (xz_ExnerBasicZ(i,k) + xz_Exner(i,k)) &
          &              * (xz_PotTempBasicZ(i,k) + xz_PotTemp(i,k)) ) &
          &         ) &
          &   )
        
      end do
    end do
    
  case ("Thermal-Random")
    ! ؤ˥ʾͿ
    
    open(20,file=RandomFile)
    do i = DimXMin, DimXMax
      read(20,*) random
      RandomNum(i) = random
    end do
    close(20)
    
    do i = DimXMin, DimXMax
      
      !ΤȤƤϥȤʤ褦Ĵ
      RandomNum2(i) = RandomNum(i)  &
        & - sum( RandomNum(RegXMin+1:RegXMax) ) / real(RegXMax - RegXMin, 8) 
      
      xz_PotTemp(i, maxloc(s_Z, s_Z <= Zpos) - MarginZ - 1) = &
        & DelMax * RandomNum2(i) / xz_ExnerBasicZ(i, maxloc(s_Z, s_Z <= Zpos) - MarginZ - 1)
      
!      write(*,*) "xz_PotTemp()", xz_PotTemp(i, - MarginZ -1)
    end do
    
    
  case ("SK1994")
    ! Skamarock and Klemp (1994) ȼ¸
    
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        xz_PotTemp(i,k) =                             &
          & DelMax * HalfWidth ** 2.0d0               &
          & * sin(pi * s_Z(k) / ZMax)                 &
          & / (HalfWidth ** 2.0d0 +                   &
          & (s_X(i) - XcRate * (XMax - XMin)) ** 2.0d0 )
      end do
    end do
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        pz_VelX(i,k)    =   20.0d0
      end do
    end do
    
  case ("KH")
     ! KH ԰¸(̾Ϳ륿)
    
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        pz_VelX(i,k)    =  4.0d0 *                           &
          & (1.0d0 + tanh((s_Z(k) - ZcRate * (ZMax - ZMin)) / ShearWidth))
      end do
    end do
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        xz_PotTemp(i,k)  =  1.0d0 *                           &
          !          & (1.0d0 + tanh((s_Z(k) - ZcRate * (ZMax - ZMin)) / ShearWidth))
          & sin(s_X(i)*2.0d0*pi/XMax)*sin(s_Z(k)*2.0d0*pi/ZMax)
      end do
    end do
    
  case ("KH-2")
    ! KH ԰¸(̾Ϳʤ)
    
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        pz_VelX(i,k)    =  3.0d0 *                             &
          & (1.0d0 + tanh((s_Z(k) - ZcRate * (ZMax - ZMin)) / ShearWidth)) &
          & + 0.2d0 * (1.0d0 +                                  &
          & sin(s_X(i)*2.0d0*pi/XMax)*sin(s_Z(k)*2.0d0*pi/ZMax))
      end do
    end do
    
  end select

end subroutine DisturbEnv_mmc
